// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by an AGPL-3.0-style license
// that can be found in the LICENSE file.

part of molview_messages.dataserver;

/// Key data
class KeyData {
  /// Key data class
  final String dataClass;

  /// Key content
  final dynamic content;

  /// Constructor
  KeyData(this.dataClass, this.content);

  /// Construct from PDS.
  factory KeyData.fromPds(Map<String, dynamic> data) {
    return new KeyData(data['class'] as String, data['content']);
  }

  /// Convert to PDS.
  Map<String, dynamic> toPds() {
    return {'class': dataClass, 'content': pdsFromDynamic(content)};
  }
}

/// Value data
class ValueData {
  /// Value data class
  final String dataClass;

  /// Value content
  final dynamic content;

  /// Constructor
  ValueData(this.dataClass, this.content);

  /// Construct from PDS.
  factory ValueData.fromPds(Map<String, dynamic> data) {
    return new ValueData(data['class'] as String, data['content']);
  }

  /// Convert to PDS.
  Map<String, dynamic> toPds() {
    return {'class': dataClass, 'content': pdsFromDynamic(content)};
  }
}
